/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM
 * /builds/moz2_slave/mozilla-1.9.2-linux64-xulrunner/build/js/ctypes/nsIForeignLibrary.idl
 */

package org.mozilla.interfaces;

/**
 * Interface that wraps a dynamic library and can create
 * callable 'method' objects from exportable functions in the library
 */
public interface nsIForeignLibrary extends nsISupports {

  String NS_IFOREIGNLIBRARY_IID =
    "{352a72c1-5b99-451e-a330-c45079d8f087}";

  /**
   * ABI constants that specify the calling convention to use.
   * DEFAULT corresponds to the cdecl convention, and in almost all
   * cases is the correct choice. STDCALL is provided for calling
   * functions in the Microsoft Win32 API.
   */
  int DEFAULT = 0;

  int STDCALL = 1;

  /**
   * Types available for arguments and return values, representing
   * their C counterparts.
   */
  int VOID = 0;

  int BOOL = 1;

  int INT8 = 2;

  int INT16 = 3;

  int INT32 = 4;

  int INT64 = 5;

  int UINT8 = 6;

  int UINT16 = 7;

  int UINT32 = 8;

  int UINT64 = 9;

  int FLOAT = 10;

  int DOUBLE = 11;

  int STRING = 12;

  int USTRING = 13;

  /**
   * Attempts to dynamically load the specified library
   */
  void open(nsILocalFile aFile);

  /**
   * Unloads the currently loaded library. Any subsequent attempts to call
   * functions on this interface will fail.
   */
  void close();

  /**
   * Used to specify an exported method from the currently loaded library. Even
   * though the method appears to take no parameters, it does in fact require
   * several. It uses some XPCOM/JSAPI magic to extract the parameters.
   *
   * declare(in AString aName, in int aABI, in int aReturnType, in int aArgType1, ...)
   *
   * The resulting object can then be used to call the underlying
   * C function like so:
   *
   * var retval = nativeMethod(arg1, arg2, ...);
   *
   * Arguments will be checked against the types supplied at declaration, and
   * some attempt to convert values (e.g. boolean true/false to integer 0/1)
   * will be made. Otherwise, if types do not match, or conversion fails,
   * an exception will be thrown.
   */
  nsISupports declare();

}